
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>单片机中C语言的程序与数据存储 / 憋错料</title>

    <meta name="description" content="单片机中C语言的程序与数据存储 单片机中C语言的程序与数据存储 一.五大内存分区: 内存分成5个区,它们分别是堆.栈.自由存储区.全局/静态存储区和常量存储区. 1.栈区(stack):FIFO就是那些由编译器在需要的时候分配,在不需要的时候自动清除的变量的存储区.里面的变量通常是局部变量.函数参数等. 2.堆区(heap):就是那些由new分配的内存块,它们的释放编译器不去管,由我们的应用程序去控制,一般一个new就要对应一个delete.如果程序员没有释放掉,那么在程序结束后,操作系统会自动回收. 3.自由存储区:就是那些">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">单片机中C语言的程序与数据存储</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>单片机中C语言的程序与数据存储</h2>
<p><strong>一、五大内存分区：</strong></p>
<p>内存分成5个区，它们分别是堆、栈、自由存储区、全局/静态存储区和常量存储区。</p>
<p>1、栈区(stack)：FIFO就是那些由编译器在需要的时候分配，在不需要的时候自动清除的变量的存储区。里面的变量通常是局部变量、函数参数等。</p>
<p>2、堆区(heap)：就是那些由new分配的内存块，它们的释放编译器不去管，由我们的应用程序去控制，一般一个new就要对应一个delete。如果程序员没有释放掉，那么在程序结束后，操作系统会自动回收。</p>
<p>3、自由存储区：就是那些由malloc等分配的内存块，它和堆是十分相似的，不过它是用free来结束自己的生命。</p>
<p>4、全局/静态存储区：全局变量和静态变量被分配到同一块内存中，在以前的C语言中，全局变量又分为初始化的和未初始化的，在C++里面没有这个区分了，他们共同占用同一块内存区。</p>
<p>5、常量存储区：这是一块比较特殊的存储区，它们里面存放的是常量，不允许修改（当然，你要通过非正当手段也可以修改，而且方法很多）</p>
<p>code/data/stack</p>
<p>内存主要分为代码段，数据段和堆栈。代码段放程序代码，属于只读内存。数据段存放全局变量，静态变量，常量等，堆里存放自己malloc或new出来的变量，其他变量就存放在栈里，堆栈之间空间是有浮动的。数据段的内存会到程序执行完才释放。调用函数先找到函数的入口地址，然后计算给函数的形参和临时变量在栈里分配空间，拷贝实参的副本传给形参，然后进行压栈操作，函数执行完再进行弹栈操作。字符常量一般放在数据段，而且相同的字符常量只会存一份。</p>
<p><strong>二、C语言程序的存储区域</strong></p>
<p>1、由C语言代码（文本文件）形成可执行程序（二进制文件），需要经过编译-汇编-连接三个阶段。编译过程把C语言文本文件生成汇编程序，汇编过程把汇编程序形成二进制机器代码，连接过程则将各个源文件生成的二进制机器代码文件组合成一个文件。</p>
<p>2、C语言编写的程序经过编译-连接后，将形成一个统一文件，它由几个部分组成。在程序运行时又会产生其他几个部分，各个部分代表了不同的存储区域：</p>
<p>1）代码段（Code或Text）</p>
<p>代码段由程序中执行的机器代码组成。在C语言中，程序语句执行编译后，形成机器代码。在执行程序的过程中，CPU的程序计数器指向代码段的每一条机器代码，并由处理器依次运行。</p>
<p>2）只读数据段(RO data)</p>
<p>只读数据段是程序使用的一些不会被更改的数据，使用这些数据的方式类似查表式的操作，由于这些变量不需要更改，因此只需要放置在只读存储器中即可。</p>
<p>3）已初始化读写数据段(RW data)</p>
<p>已初始化数据是在程序中声明，并且具有初值的变量，这些变量需要占用存储器的空间，在程序执行时它们需要位于可读写的内存区域内，并且有初值，以供程序运行时读写。</p>
<p>4）未初始化数据段(BBS)</p>
<p>未初始化数据是在程序中声明，但是没有初始化的变量，这些变量在程序运行之前不需要占用存储器的空间。</p>
<p>5）堆(heap)</p>
<p>堆内存只在程序运行时出现，一般由程序员分配和释放。在具有操作系统的情况下，如果程序没有释放，操作系统可能在程序(例如一个进程)结束后会后内存。</p>
<p>6）栈（statck）</p>
<p>堆内存只在程序运行时出现，在函数内部使用的变量，函数的参数以及返回值将使用栈空间，栈空间由编译器自动分配和释放。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuc2luYWltZy5jbi9tdzY5MC8wMDFnejRTWmd5NlA4Ulo0U1Q4YzI=.jpg" />填写图片摘要（选填）</p>
<p>3、代码段、只读数据段、读写数据段、未初始化数据段属于静态区域，而堆和栈属于动区域。代码段、只读数据段和读写数据段将在连接之后产生，未初始化数据段将在程序初始化的时候开辟，而对堆和栈将在程序饿运行中分配和释放。</p>
<p>4、C语言程序分为映像和运行时两种状态。在编译-连接后形成的映像中，将只包含代码段(Text)、只读数据段(R0 Data)和读写数据段（RW Data）。在程序运行之前，将动态生成未初始化数据段(BSS)，在程序的运行时还将动态生成堆(Heap)区域和栈（Stack）区域。</p>
<p>注：</p>
<p>1、一般来说，在静态的映像文件中，各个部分称之为节(Section)，而在运行时的各个部分称之为段(Segment)。如果不详细区分，统称为段。</p>
<p>2、C语言在编译连接后，将生成代码段(TEXT)，只读数据段(RO Data)和读写数据段(RW Data)。在运行时，除了上述三个区域外，还包括未初始化数据段(BBS)区域和堆（heap）区域和栈（Stack）区域。</p>
<p><strong>三、C语言程序的段</strong></p>
<p>1、段的分类</p>
<p>每一个源程序生成的目标代码将包含源程序所需要表达的所有信息和功能。目标代码中各段生成情况如下：</p>
<p>1）代码段（Code）</p>
<p>代码段由程序中的各个函数产生，函数的每一个语句将最终经过编译和汇编生成二进制机器代码</p>
<p>2）只读数据段(RO Data)</p>
<p>只读数据段由程序中所使用的数据产生，该部分数据的特点在运行中不需要改变，因此编译器会将数据放入只读的部分中。C语言的一些语法将生成只读数据数据段。</p>
<p>2、只读数据段(RO Data)</p>
<p>只读数据段(RO Data)由程序中所使用的数据产生，该部分数据的特点是在运行中不需要改变，因此编译器会将数据放入只读的部分中。以下情况将生成只读数据段。</p>
<p>1）只读全局变量</p>
<p>定义全局变量const char a[100]=”abcdefg”将生成大小为100个字节的只读数据区，并使用字符串“abcdefg”初始化。如果定义为const char a[]=”abcdefg”,没有指定大小，将根据“abcdefgh”字串的长度，生成8个字节的只读数据段。</p>
<p>2）只读局部变量</p>
<p>例如：在函数内部定义的变量const char b[100]=”9876543210”;其初始化的过程和全局变量。</p>
<p>3）程序中使用的常量</p>
<p>例如：在程序中使用printf("information\n”),其中包含了字串常量，编译器会自动把常量“information \n”放入只读数据区。</p>
<p>注：在const char a[100]={“ABCDEFG”}中，定义了100个字节的数据区，但是只初始化了前面的8个字节（7个字符和表示结束符的‘\0’）。在这种用法中，实际后面的字节米有初始化，但是在程序中也不能写，实际上没有任何用处。因此，在只读数据段中，一般都需要做完全的的初始化。</p>
<p>3、读写数据段（RW Data）</p>
<p>读写数据段表示了在目标文件中一部分可以读也可以写的数据区，在某些场合它们又被称为已初始化数据段。这部分数据段和代码，与只读数据段一样都属于程序中的静态区域，但是具有科协的特点。</p>
<p>1）已初始化全局变量</p>
<p>例如：在函数外部，定义全局的变量char a[100]=”abcdefg”</p>
<p>2）已初始化局部静态变量</p>
<p>例如：在函数中定义static char b[100]=”9876543210”。函数中由static定义并且已经初始化的数据和数组将被编译为读写数据段。</p>
<p>说明：</p>
<p>读写数据区的特点是必须在程序中经过初始化，如果只有定义，没有初始值，则不会生成读写数据区，而会定义为未初始化数据区(BSS)。如果全局变量（函数外部定义的变量）加入static修饰符，写成static char a[100]的形式，这表示只能在文件内部使用，而不能被其他文件使用。</p>
<p>4、未初始化数据段(BSS)</p>
<p>未初始化数据段常被称之为BSS(英文名为Block start by symbol的缩写)。与读写数据段类似，它也属于静态数据区。但是该段中数据没有经过初始化。因此它只会在目标文件中被标识，而不会真正称为目标文件中的一个段，该段将会在运行时产生。未初始化数据段只有在运行的初始化阶段才会产生，因此它的大小不会影响目标文件的大小。</p>
<p><strong>四、在C语言的程序中，对变量的使用还有以下注意</strong></p>
<p>1、在函数体中定义的变量通常是在栈上，不需要在程序中进行管理，由编译器处理。</p>
<p>2、用malloc，calloc,realoc等分配分配内存的函数所分配的内存空间在堆上，程序必须保证在使用后使用后freee释放，否则会发生内存泄漏。</p>
<p>3、所有函数体外定义的是全局变量，加了static修饰符后的变量不管在函数内部或者外部存放在全局区（静态区）。</p>
<p>4、使用const定义的变量将放于程序的只读数据区。</p>
<p>说明：</p>
<p>在C语言中，可以定义static变量：在函数体内定义的static变量只能在该函数体内有效；在所有函数体外定义的static变量，也只能在该文件中有效，不能在其他源文件中使用；对于没有使用 static修饰的全局变量，可以在其他的源文件中使用。这些区别是编译的概念，即如果不按要求使用变量，编译器会报错。使用static 和没使用static修饰的全局变量最终都将放置在程序的全局去（静态去）。</p>
<p><strong>五、程序中段的使用</strong></p>
<p>C语言中的全局区（静态区），实际上对应着下述几个段：</p>
<p>只读数据段:RO Data</p>
<p>读写数据段：RW Data</p>
<p>未初始化数据段：BSS Data</p>
<p>一般来说，直接定义的全局变量在未初始化数据区，如果该变量有初始化则是在已初始化数据区（RW Data）,加上const修饰符将放置在只读区域(RO Data).</p>
<p>例如:</p>
<p>const char ro[ ]=”this is a readonlydata”; //只读数据段，不能改变ro数组中的内容，ro存放在只读数据段。</p>
<p>char rw1[ ]=”this is global readwrite data”; //已初始化读写数据段，可以改变数组rw1中的内容。应为数值/是赋值不是把”this is global readwrite data” 地址给了rw1，不能改变”this is global readwrite data”的数值。因为起是文字常量放在只读数据段中</p>
<p>char bss_1[100];//未初始化数据段</p>
<p>const char *ptrconst = “constant data”; //”constant data”放在只读数据段，不能改变ptrconst中的值，因为其是地址赋值。ptrconst指向存放“constant data”的地址，其为只读数据段。但可以改变ptrconst地址的数值，因其存放在读写数据段中。</p>
<p>实例讲解：</p>
<p>int main( )</p>
<p>{</p>
<p>short b;//b放置在栈上，占用2个字节</p>
<p>char a[100];//需要在栈上开辟100个字节，a的值是其首地址</p>
<p>char s[]=”abcde”;</p>
<p>//s在栈上，占用4个字节，“abcde”本身放置在只读数据存储区，占6字节。s是一个地址</p>
<p>//常量，不能改变其地址数值，即s++是错误的。</p>
<p>char *p1;&nbsp;&nbsp;//p1在栈上，占用4个字节</p>
<p>char *p2 ="123456";&nbsp;&nbsp;//"123456"放置在只读数据存储区，占7个字节。p2在栈上，p2指向的内容不能更</p>
<p>//改，但是p2的地址值可以改变，即p2++是对的。</p>
<p>static char bss_2[100]; //局部未初始化数据段</p>
<p>static int c=0 ; //局部（静态）初始化区</p>
<p>p1 = (char *)malloc(10*sizeof(char)); //分配的内存区域在堆区</p>
<p>strcpy(p1,”xxx”); //”xxx”放置在只读数据存储区，占5个字节</p>
<p>free(p1); //使用free释放p1所指向的内存</p>
<p>return 0;</p>
<p>}</p>
<p>说明：</p>
<p>1、只读数据段需要包括程序中定义的const型的数据（如：const char ro[]）,还包括程序中需要使用的数据如“123456”。对于const char ro[]和const char * ptrconst的定义，它们指向的内存都位于只读数据据区，其指向的内容都不允许修改。区别在于前者不允许在程序中修改ro的值，后者允许在程序中修改ptrconst本身的值。对于后者，改写成以下的形式，将不允许在程序中修改ptrconst本身的值：</p>
<p>const char * const ptrconst = “const data”;</p>
<p>2、读写数据段包含了已经初始化的全局变量static char rw1[]以及局部静态变量static char</p>
<p>rw2[]。rw1和rw2的差别在于编译时，是在函数内部使用的还是可以在整个文件中使用。对于前者，static修饰在于控制程序的其他文件时候可以访问rw1变量，如果有static修饰，将不能在其他的C语言源文件中使用rw1，这种影响针对编译-连接的特性，但无论有static，变量rw1都将被放置在读写数据段。对于后者rw2,它是局部的静态变量，放置在读写数据区；如果不使用static修饰，其意义将完全改变，它将会是开辟在栈空间局部变量，而不是静态变量。</p>
<p>3、未初始化数据段，事例1中的bss_1[100]和 bss_2[200]在程序中代表未初始化的数据段。其区别在于前者是全局的变量，在所有文件中都可以使用；后者是局部的变量，只在函数内部使用。未初始化数据段不设置后面的初始化数值，因此必须使用数值指定区域的大小，编译器将根据大小设置BBS中需要增加的长度。</p>
<p>4、栈空间包括函数中内部使用的变量如short b和char a[100]，以及char *p1中p1这个变量的值。</p>
<p>1）变量p1指向的内存建立在堆空间上，堆空间只能在程序内部使用，但是堆空间(例如p1指向的内存)可以作为返回值传递给其他函数处理。</p>
<p>2）栈空间主要用于以下3类数据的存储：</p>
<p>a、函数内部的动态变量</p>
<p>b、函数的参数</p>
<p>c、函数的返回值</p>
<p>3）栈空间主要的用处是供函数内部的动态变量使用，变量的空间在函数开始之前开辟，在函数退出后由编译器自动回收。看一个例：</p>
<p>int main( )</p>
<p>{</p>
<p>char *p = "tiger";</p>
<p>p[1] = ‘I‘;</p>
<p>p++;</p>
<p>printf("%s\n",p);</p>
<p>}</p>
<p>编译后提示：段错误</p>
<p>分析：</p>
<p>char *p = "tiger";系统在栈上开辟了4个字节存储p的数值。"tiger"在只读存储区中存储，因此"tiger"的内容不能改变，*p="tiger"，表示地址赋值，因此，p指向了只读存储区，因此改变p指向的内容会引起段错误。但是因为p是存放在栈上，因此p的数值是可以改变的，因此p++是正确的。</p>
<p><strong>六、const的使用</strong></p>
<p>1、前言：</p>
<p>const是一个C语言的关键字，它限定一个变量不允许被改变。使用const在一定程序上可以提高程序的健壮性，另外，在观看别人代码的时候，清晰理解const所起的作用，对理解别人的程序有所帮助。</p>
<p>2、const变量和常量</p>
<p>1）const修饰的变量，其值存放在只读数据段中，其值不能被改变。称为只读变量。</p>
<p>其形式为 const int a=5;此处可以用a代替5</p>
<p>2）常量：其也存在只读数据段中，其数值也不能被改变。其形式为"abc" ,5</p>
<p>3、const 变量和const限定的内容，先看一个事例：</p>
<p>typedef char* pStr;</p>
<p>int main( )</p>
<p>{</p>
<p>char string[6] = “tiger”;</p>
<p>const char *p1 = string;</p>
<p>const pStr p2 = string;</p>
<p>p1++;</p>
<p>p2++;</p>
<p>printf(“p1=%s\np2=%s\n”,p1,p2);</p>
<p>}</p>
<p>程序经过编译后，提示错误为</p>
<p>error:increment of read-only variable ‘p2’</p>
<p>1)const 使用的基本形式为：const char m;</p>
<p>//限定m 不可变</p>
<p>2)替换1式中的m,const char *pm;</p>
<p>//限定*pm不可变，当然pm是可变的，因此p1++是对的。</p>
<p>3)替换1式中的char,const newType m;</p>
<p>//限定m不可变，问题中的pStr是一种新类型，因此问题中p2不可变，p2++是错误的。</p>
<p>4、const 和指针</p>
<p>类型声明中const用来修饰一个常量，有如下两种写法：</p>
<p>1)const在前面</p>
<p>const int nValue;//nValue是const</p>
<p>const char *pContent;//*pContent是const,pConst可变</p>
<p>const (char *)pContent;//pContent是const,*pContent可变</p>
<p>char *const pContent;//pContent是const,*pContent可变</p>
<p>const char * const pContent;//pContent和*pContent都是const</p>
<p>2)const 在后面与上面的声明对等</p>
<p>int const nValue； // nValue是const</p>
<p>char const *pContent;&nbsp;&nbsp;//*pContent是const, pContent可变</p>
<p>(char *) constpContent;&nbsp;&nbsp;//pContent是const, *pContent可变</p>
<p>char* const pContent;&nbsp;&nbsp;&nbsp;&nbsp;// pContent是const, *pContent可变</p>
<p>char const* const pContent;&nbsp;&nbsp;//pContent和*pContent都是const</p>
<p>说明：const和指针一起使用是C语言中一个很常见的困惑之处,下面是两天规则：</p>
<p>1）沿着*号划一条线，如果const位于*的左侧，则const就是用来修饰指针所指向的变量，即指针指向为常量；如果const位于*的右侧，const就是修饰指针本身，即指针本身是常量。你可以根据这个规则来看上面声明的实际意义，相信定会一目了然。</p>
<p>2）对于const (char *) ; 因为char *是一个整体，相当于一个类型(如char)，因此，这是限定指针是const。</p>
<p><strong>七、单片机C语言中的data,idata,xdata,pdata,code</strong></p>
<p>从数据存储类型来说，8051系列有片内、片外程序存储器，片内、片外数据存储器，片内程序存储器还分直接寻址区和间接寻址类型，分别对应code、data、xdata、idata以及根据51系列特点而设定的pdata类型，使用不同的存储器，将使程序执行效率不同，在编写C51程序时，最好指定变量的存储类型，这样将有利于提高程序执行效率(此问题将在后面专门讲述)。与ANSI-C稍有不同，它只分SAMLL、COMPACT、LARGE模式，各种不同的模式对应不同的实际硬件系统，也将有不同的编译结果。</p>
<p>在51系列中data,idata,xdata,pdata的区别:</p>
<p>data:固定指前面0x00-0x7f的128个RAM，可以用acc直接读写的，速度最快，生成的代码也最小。</p>
<p>idata:固定指前面0x00-0xff的256个RAM,其中前128和data的128完全相同，只是因为访问的方式不同。idata是用类似C中的指针方式访问的。汇编中的语句为：mox ACC,@Rx.(不重要的补充：c中idata做指针式的访问效果很好)</p>
<p>xdata:外部扩展RAM，一般指外部0x0000-0xffff空间，用DPTR访问。</p>
<p>pdata:外部扩展RAM的低256个字节，地址出现在A0-A7的上时读写，用movx ACC,@Rx读写。这个比较特殊，而且C51好象有对此BUG，建议少用。但也有他的优点，具体用法属于中级问题，这里不提。</p>
<p>单片机C语言unsigned char code table[]&nbsp;&nbsp;code 是什么作用？</p>
<p>code的作用是告诉单片机，我定义的数据要放在ROM（程序存储区）里面，写入后就不能再更改，其实是相当与汇编里面的寻址MOVX(好像是)，因为C语言中没办法详细描述存入的是ROM还是RAM（寄存器），所以在软件中添加了这一个语句起到代替汇编指令的作用，对应的还有data是存入RAM的意思。</p>
<p>程序可以简单的分为code（程序）区，和data （数据）区，code区在运行的时候是不可以更改的，data区放全局变量和临时变量，是要不断的改变的，cpu从code区读取指令，对data区的数据进行运算处理，因此code区存储在什么介质上并不重要，象以前的计算机程序存储在卡片上，code区也可以放在rom里面，也可以放在ram里面，也可以放在flash里面（但是运行速度要慢很多，主要读flash比读ram要费时间），因此一般的做法是要将程序放到flash里面，然后load到 ram里面运行的;DATA区就没有什么选择了，肯定要放在RAM里面，放到rom里面改动不了。</p>
<p>bdata如何使用它呢？<br />若程序需要8个或者更多的bit变量，如果你想一次性给8个变量赋值的话就不方便了，（举个例子说说它的方便之处，想更深入的了解请在应用中自己琢磨）又不可以定义bit数组，只有一个方法</p>
<p>char bdata MODE;<br />sbit MODE_7 = MODE^7;<br />sbit MODE_6 = MODE^6;<br />sbit MODE_5 = MODE^5;<br />sbit MODE_4 = MODE^4;<br />sbit MODE_3 = MODE^3;<br />sbit MODE_2 = MODE^2;<br />sbit MODE_1 = MODE^1;<br />sbit MODE_0 = MODE^0;<br />8个bit变量MODE_n 就定义好了<br />这是定义语句，Keilc 的特殊数据类型。记住一定要是sbit<br />不能 bit MODE_0 = MODE^0;<br />赋值语句要是这么写C语言就视为异或运算。</p>
<p>Flash相对单片机里的RAM属于外部存取器，虽其结构位置装在单片机中，其实xdata是放在相对RAM的外面，而flash正是相对RAM外面。</p>
<p>int&nbsp;a&nbsp;变量定义在内部RAM,xdata&nbsp;int&nbsp;a&nbsp;定义在外部RAM或flash，uchar code&nbsp;a&nbsp;定义在flash。</p>
<p>uchar code duma[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f,0x40,0x00}; //共阴的数码管段选,P2口要取的数值</p>
<p>若定义 uchar aa[5],aa[5]中的内容是存放在数据存储区（RAM）中的，在程序运行工程中各个数组元素的值可以被修改，掉电后aa[5]中的数据无法保存。</p>
<p>若定义 uchar code bb[5]中的内容是存放在程序存储区（如flash）中的,只有在烧写程序时，才能改变bb[5]中的各元素的值，在程序运行工程中无法修改，并且掉电后bb[5]中的数据不消失。</p>
<p><strong>八、C语言中堆和栈的区别</strong></p>
<p>C语言程序经过编译连接后形成编译、连接后形成的二进制映像文件由栈、堆、数据段（由三部分部分组成：只读数据段，已经初始化读写数据段，未初始化数据段即BBS）和代码段组成，如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEwLnNpbmFpbWcuY24vbXc2OTAvMDAxZ3o0U1pneTZQOWZ1cFV0cmY5JmFtcDs2OTA=.jpg" /></p>
<table>
<tbody>
<tr>
<td colspan="3"></td>
</tr>
</tbody>
</table>
<p>1、栈区(stack):由编译器自动分配释放，存放函数的参数值，局部变量等值。其操作方式类似于数据结构中的栈。</p>
<p>2、堆区(heap):一般由程序员分配释放，若程序员不释放，则可能会引起内存泄漏。注堆和数据结构中的堆栈不一样，其类是与链表。</p>
<p>3、程序代码区：存放函数体的二进制代码。</p>
<p>4、数据段：由三部分组成：</p>
<p>1）只读数据段：</p>
<p>只读数据段是程序使用的一些不会被更改的数据，使用这些数据的方式类似查表式的操作，由于这些变量不需要更改，因此只需要放置在只读存储器中即可。一般是const修饰的变量以及程序中使用的文字常量一般会存放在只读数据段中。</p>
<p>2）已初始化的读写数据段：</p>
<p>已初始化数据是在程序中声明，并且具有初值的变量，这些变量需要占用存储器的空间，在程序执行时它们需要位于可读写的内存区域内，并且有初值，以供程序运行时读写。在程序中一般为已经初始化的全局变量，已经初始化的静态局部变量(static修饰的已经初始化的变量)</p>
<p>3）未初始化段（BSS）：</p>
<p>未初始化数据是在程序中声明，但是没有初始化的变量，这些变量在程序运行之前不需要占用存储器的空间。与读写数据段类似，它也属于静态数据区。但是该段中数据没有经过初始化。未初始化数据段只有在运行的初始化阶段才会产生，因此它的大小不会影响目标文件的大小。在程序中一般是没有初始化的全局变量和没有初始化的静态局部变量。</p>
<h2>堆和栈的区别</h2>
<p>1、申请方式</p>
<p>(1)栈（satck）:由系统自动分配。例如，声明在函数中一个局部变量int b;系统自动在栈中为b开辟空间。</p>
<p>(2)堆（heap）:需程序员自己申请（调用malloc,realloc,calloc）,并指明大小，并由程序员进行释放。容易产生memory leak.</p>
<table>
<tbody>
<tr>
<td colspan="3"></td>
</tr>
</tbody>
</table>
<p>eg:char&nbsp;&nbsp;p;</p>
<p>p = (char *)malloc(sizeof(char));&nbsp;&nbsp;&nbsp;&nbsp;//但是，p本身是在栈中。</p>
<p>2、申请大小的限制</p>
<p>1）栈：在windows下栈是向底地址扩展的数据结构，是一块连续的内存区域(它的生长方向与内存的生长方向相反)。栈的大小是固定的。如果申请的空间超过栈的剩余空间时，将提示overflow。</p>
<p>2）堆：堆是高地址扩展的数据结构（它的生长方向与内存的生长方向相同），是不连续的内存区域。这是由于系统使用链表来存储空闲内存地址的，自然是不连续的，而链表的遍历方向是由底地址向高地址。堆的大小受限于计算机系统中有效的虚拟内存。</p>
<p>3、系统响应：</p>
<p>1）栈：只要栈的空间大于所申请空间，系统将为程序提供内存，否则将报异常提示栈溢出。</p>
<p>2）堆：首先应该知道操作系统有一个记录空闲内存地址的链表，但系统收到程序的申请时，会遍历该链表，寻找第一个空间大于所申请空间的堆结点，然后将该结点从空闲链表中删除，并将该结点的空间分配给程序，另外，对于大多数系统，会在这块内存空间中的首地址处记录本次分配的大小，这样，代码中的free语句才能正确的释放本内存空间。另外，找到的堆结点的大小不一定正好等于申请的大小，系统会自动的将多余的那部分重新放入空闲链表中。</p>
<p>说明：对于堆来讲，对于堆来讲，频繁的new/delete势必会造成内存空间的不连续，从而造成大量的碎片，使程序效率降低。对于栈来讲，则不会存在这个问题，</p>
<p>4、申请效率</p>
<p>1）栈由系统自动分配，速度快。但程序员是无法控制的</p>
<p>2）堆是由malloc分配的内存，一般速度比较慢，而且容易产生碎片，不过用起来最方便。</p>
<p>5、堆和栈中的存储内容</p>
<p>1）栈：在函数调用时，第一个进栈的主函数中后的下一条语句的地址，然后是函数的各个参数，参数是从右往左入栈的，然后是函数中的局部变量。注：静态变量是不入栈的。</p>
<p>当本次函数调用结束后，局部变量先出栈，然后是参数，最后栈顶指针指向最开始存的地址，也就是主函数中的下一条指令，程序由该点继续执行。</p>
<p>2）堆：一般是在堆的头部用一个字节存放堆的大小。</p>
<p>6、存取效率</p>
<p>1）堆：char *s1=”hellow&nbsp;tigerjibo”;是在编译是就确定的</p>
<p>2）栈：char s1[]=”hellow&nbsp;tigerjibo”;是在运行时赋值的；用数组比用指针速度更快一些，指针在底层汇编中需要用edx寄存器中转一下，而数组在栈上读取。</p>
<p>补充：</p>
<p>栈是机器系统提供的数据结构，计算机会在底层对栈提供支持：分配专门的寄存器存放栈的地址，压栈出栈都有专门的指令执行，这就决定了栈的效率比较高。堆则是C/C++函数库提供的，它的机制是很复杂的，例如为了分配一块内存，库函数会按照一定的算法（具体的算法可以参考数据结构/操作系统）在堆内存中搜索可用的足够大小的空间，如果没有足够大小的空间（可能是由于内存碎片太多），就有可能调用系统功能去增加程序数据段的内存空间，这样就有机会分到足够大小的内存，然后进行返回。显然，堆的效率比栈要低得多。</p>
<p>7、分配方式：</p>
<p>1）堆都是动态分配的，没有静态分配的堆。</p>
<p>2）栈有两种分配方式：静态分配和动态分配。静态分配是编译器完成的，比如局部变量的分配。动态分配由alloca函数进行分配，但是栈的动态分配和堆是不同的。它的动态分配是由编译器进行释放，无需手工实现。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 20:48:37 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/c%e8%af%ad%e8%a8%80/" title="c语言">c语言</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>单片机中C语言的程序与数据存储的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35bEao4.html" rel="bookmark">三种iOS应用程序用户数据存储方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文通过偏好设置,plist文件,归档解档三种方法来演示iOS应用程序用户数据存储机制. 首先,我们创建一个Person类,并定义三个成员属性,用来存储数据 @property (nonatomic,copy) NSString *name; @property (nonatomic,assign)NSInteger age; @property (nonatomic,assign)BOOL isTrue; 一.通过偏好设置 1.通过偏好设置存储数据 //获取偏好设置的对象 NSUserDefa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AnpoyM.html" rel="bookmark">Android中Activity执行restart过程中涉及到的四种数据存储恢复的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们知道,当Configuration Change发生的时候(比如横竖屏切换等),会导致Activity重启,即先destroy,然后会restart,一般情况下restart的时间比较短,为了保证一致的用户体验,我们应该在Activity重启前将一些数据存储下来,然后在restart的时候重新根据这些数据更新UI.当然你可能想将这些数据写到物理文件或数据库中,但是这样有缺点,因为IO操作时耗时操作,会影响restart的过程,甚至导致ANR程序无响应,本文将介绍几种将数据缓存在内存中以便re			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLWdoA4.html" rel="bookmark">浅谈单片机中C语言与汇编语言的转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做了一单片机设计,要用C语言与汇编语言同时实现,现将这次设计的感受和收获,还有遇到的问题写下,欢迎感兴趣的朋友交流想法,提出建议. 单片机设计:基于51单片机的99码表设计 软件环境:Proteus8.0 + Keil4 要求:1,开关按一下,数码管开始计时.2,按两下,数码管显示静止.3,按三下,数码管数值清零. C语言程序如下: 1 #include&lt;reg51.h&gt; 2 #define uint unsigned int 3 #define uchar unsigned char 4 u			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXDDXkM.html" rel="bookmark">【转载】单片机中c语言&OpenCurlyDoubleQuote;右移&amp;gt&semi;&amp;gt&semi;和左移&amp;lt&semi;&amp;lt&semi;&rdquo;与CY</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				======================================================== 左移 &lt;&lt; 0100 1111  &lt;&lt; 1   左移一位:1001 1110  CY=0 : 移出去的MSB跑到CY上,最后一位补0 : ======================================================== 右移&gt;&gt;1000 1111 &gt;&gt;1    右移一位:0100 0111  CY=1 : 移出去的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RkoWy3.html" rel="bookmark">在SpringMVC中使用&commat;SessionAttributes和&commat;ModelAttribute将数据存储在session域中</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天在我的springMVC项目--图书管理系统中,希望在登录时将登录的Users存在session中,开始是准备在controller中使用Servlet API中的对象,可是一直无法引用,不知道为什么,难道是要导入什么特定的包吗(如果有知道的朋友,可以的话麻烦留言告诉我下,谢谢了),然后看见网上说可以用@SessionAttributes和@ModelAttribute注释来实现,具体实现如下: UserController类: @Controller@SessionAttributes(&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eypyD0.html" rel="bookmark">iOS狂暴之路---iOS中应用的数据存储方式解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.前言 前面一篇文章中已经介绍了iOS应用中的视图控制器知识点,而本文不会按照常理来介绍View的知识点,而是先介绍iOS中的数据存储知识点,因为关于View的知识点太多了,后面会连续详细介绍一下.这篇先来看一下iOS中的数据存储功能分析.每一个iOS应用和Android应用一样,都有其对应的沙盒存储自己的数据,但是iOS和Android有一个区别就在于没有SD卡的概念了,也就说在iOS中应用的数据只能保存到自己的沙盒中.这也可以看出来iOS为了应用的安全考虑. 在开发Android的时候都知			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38y1Q24.html" rel="bookmark">【Cocos2d-x游戏开发】Cocos2d-x中的数据存储技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.引言 数据存储和网络功能可以说是一款游戏中必不可少的功能,如果一款游戏不能保存进度那么它的可玩性必然大打折扣(试想一下,玩家辛辛苦苦玩了一整天的游戏,结果退出时告诉人家不能保存关卡信息,你明天还得从头来再玩一遍.那玩家一定会掏出准备已久的西瓜刀~) 其实Cocos2d-x引擎早已为我们开发者封装好了多种数据存储的类或者方法,包括简单信息的存储,文件的读写,SQLite数据库和RAR格式的压缩文件的读取等等.(用心良苦啊!)其中大部分的存储功能被封装到了UserDefault类中. 二.数据存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j5bDEM.html" rel="bookmark">阅读郭林《第一行代码》的笔记&mdash;&mdash;第6章 数据存储全方案，详解持久化技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				瞬时数据是指那些存储在内存当中,有可能会因为程序关闭或其他原因导致内存被回收而丢失的数据.这对于一些关键性的数据信息来说是绝对不能容忍的,谁都不希望自己刚发出去的一条微博,刷新一下就没了吧.那么怎样才能保证让一些关键性的数据不会丢失呢?这就需要用到数据持久化技术了. 持久化技术简介 数据持久化就是指将那些内存中的瞬时数据保存到存储设备中,保证即使在手机或电脑关机的情况下,这些数据仍然不会丢失.保存在内存中的数据是处于瞬时状态的,而保存在存储设备中的数据是处于持久状态的,持久化技术则是提供了一种机			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6N71vM.html" rel="bookmark">Android基础知识&lpar;6&rpar;&mdash;数据持久化之数据存储</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阅读前,请浏览此处上方目录. Android基础知识(6)-数据持久化之数据存储 本章内容为个人笔记,参考书籍有:&lt;疯狂的android&gt;第3版.&lt;第一行代码&gt; 首先,我们要知道什么是数据持久化. 数据持久化就是指那些内存中的瞬时数据保存到存储设备中,保证即使手机在关机的情况下,这些数据不会丢失.保存在内存中的数据是处于瞬时状态,保存在存储设备中的数据是处于持久状态.持久化技术则是提供了一种机制可以让数据在瞬时状态和持久状态之间进行转换. Android系统主要提供了三种方式用于简			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyWrL3.html" rel="bookmark" class="title">多个蚂蚁过独木桥，求通过的最长时间和最短时间</a>
					<div>
						首先对题目进行分析: 求最长时间也就是最后掉下去的一只蚂蚁需要经历的最长时间: 求最短时间也就是最后掉下去的一只蚂蚁需要经历的最短时间:所以让所有的蚂蚁都向距离它们最近的那一段走,这样它们每个走的时间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kWQd0.html" rel="bookmark" class="title">java基础知识要点总结之几个重要关键字（关于static、this、final、）</a>
					<div>
						you don't get anythin unless you create an object of that class with new, and at that point data sto ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0K5Wy4.html" rel="bookmark" class="title">一名Android开发者的微信小程序填坑之路&lpar;1&rpar;</a>
					<div>
						前言 首先要声明的是,我是一名 Android 开发者,之前基本没有前端开发经验,甚至连 JS ,HTML 都是为了开发小程序现学的一些皮毛--所以文章中所提到的一些点也许在资深前端开发者看来只是小c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPN2Nm3.html" rel="bookmark" class="title">2 黑盒测试以及等价类划分的应用</a>
					<div>
						黑盒测试的基本概念 黑盒测试:是一种常用的软件测试方法,它将被测软件看作一个打不开的黑盒,主要根据功能需求设计测试用例,进行测试. 黑盒测试是一种从软件外部对软件实施的测试,也称功能测试或基于规格说明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bngGv0.html" rel="bookmark" class="title">微信获取二维码</a>
					<div>
						String listUrl = &quot;https://api.weixin.qq.com/cgi-bin/qrcode/create?access_token=&quot;+accessTok ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388qkR3.html" rel="bookmark" class="title">复制拷贝函数&plus;重载operator&equals;</a>
					<div>
						首先,如下写法: Class A = B; Class A; A = B; 并不等价,前者等价于A(B),后者等价于A.operator=(B) 问题源于我想要用类似如下写法完成复制拷贝函数 Clas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vK7yX4.html" rel="bookmark" class="title">201671010112   2016~2017-2《java程序设计》</a>
					<div>
						周次 (阅读/编写)代码行数 发布博客里/博客评论数里 课堂/课余学习时间(小时) 最满意的编程任务 第1周          18/40            1/0              6/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5xPq4.html" rel="bookmark" class="title">Unity 多物体联动动画</a>
					<div>
						在网络层,互联网提供所有应用程序都要使用的两种类型的服务,尽管目前理解这些服务的细节并不重要,但在所有TCP/IP概述中,都不能忽略他们: 无连接分组交付服务(Connectionless Packe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmDxkV4.html" rel="bookmark" class="title">PHP控制反转（IOC）和依赖注入（DI）</a>
					<div>
						先看一个例子: &lt;?php class A { public $b; public $c; public function A() { //TODO } public function Meth ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qv5zp4.html" rel="bookmark" class="title">shell 脚本 计算 1加到100 的和</a>
					<div>
						#!/bin/bash # i=0 n=1 //定义循环变量 while [ $n -lt 101 ];do //定义循环条件 n &lt; 101 i=$(( $i + $n )) //累加 n=$ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZwQlM.html" rel="bookmark" class="title">Metasploit没有db&lowbar;autopwn命令的解决办法</a>
					<div>
						将附件db_autopwn.rp 拷贝到/opt/framework3/msf3/plugins/PS:db_autopwn.rp 下载地址:http://dl.vmall.com/c04w8czlc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ML2YVO3.html" rel="bookmark" class="title">python 后台爆破工具</a>
					<div>
						sys:使用sys模块获得脚本的参数 queue模块,创建一个“队列”对象 time 模块     Python time time() 返回当前时间的时间戳(1970纪元后经过的浮点秒数). fin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7yXv4.html" rel="bookmark" class="title">页面出现假死的问题</a>
					<div>
						下面谈论的是Chrome浏览器. 很早以前,我就遇到过页面假死的现象.具体表现是:在标签页上一直转圈,页面不能打开.使用当前浏览器重新访问同一域名,会出现同样的现象. 最近我在工作中再次遇到这个问题. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLZJok3.html" rel="bookmark" class="title">机器学习与数据挖掘-支持向量机&lpar;SVM&rpar;（一）</a>
					<div>
						最近在看斯坦福大学的机器学习的公开课,学习了支持向量机,再结合网上各位大神的学习经验总结了自己的一些关于支持向量机知识. 一.什么是支持向量机(SVM)? 1.支持向量机(Support Vector ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvQLd3.html" rel="bookmark" class="title">iOS开发之oc--类与对象（2）-set&sol;get方法及构造方法</a>
					<div>
						面向对象的特征: 1)封装  2)继承 3)多态 知识点: (1)set/get方法(成员变量的封装) (2)构造方法 (3)self的使用 (4)对象方法和类方法 小知识点补充 (一)set/get ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RnpLR0.html" rel="bookmark" class="title">Mybatis&lpar;四&rpar; 高级映射，一对一，一对多，多对多映射</a>
					<div>
						天气甚好,怎能不学习? 一.单向和双向 包括一对一,一对多,多对多这三种情况,但是每一种又分为单向和双向,在hibernate中我们就详细解析过这单向和双向是啥意思,在这里,在重复一遍,就拿一对多这种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLoJV4.html" rel="bookmark" class="title">RESTful Api 身份认证安全性设计</a>
					<div>
						REST是一种软件架构风格.RESTful Api 是基于 HTTP 协议的 Api,是无状态传输.它的核心是将所有的 Api 都理解为一个网络资源.将所有的客户端和服务器的状态转移(动作)封装到 H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWxP50.html" rel="bookmark" class="title">【海岛帝国模拟赛】No&period;2 海岛帝国：&OpenCurlyDoubleQuote;落汤鸡&rdquo;市的黑帮危机</a>
					<div>
						50200210海岛帝国:“落汤鸡”市的黑帮危机 [试题描述] 近几天,犯罪分子发现“药师傅”帝国的警力约等于0.(请见YSF的海岛帝国)于是开始猖狂了起来.他们选择了依山靠水(农村?)的“落汤鸡”市 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXlreaM.html" rel="bookmark" class="title">获取图片属性详细信息</a>
					<div>
						获取图片属性详细信息,通过PIL库实现,PIL库为2.9.0(3.0版本以下) python代码实现 #-*-coding:utf8-*- from PIL import Image from PIL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVRoayM.html" rel="bookmark" class="title">在开发中使用Mockito进行测试</a>
					<div>
						关于单元测试的一些问题 当我们Javaweb项目中编写单元测试的时候,通常会面临一个普遍的问题:需要测试的类会有很多依赖,而这些依赖的类或者对象又会有很多别的依赖,导致我们在写单元测试的时候几乎需要把 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
